unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ListBox1: TListBox;
    Label1: TLabel;
    Button2: TButton;
    Button3: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    Stop: Boolean;
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

function summeDerEchtenTeiler(const n: integer):integer;
  var i : integer;
begin
  result := 1; // 1 ist immer Teiler
  for i := 2 to round(sqrt(n)) do
    if n mod i = 0 then result := result + i + n div i;
end;

procedure TForm1.Button1Click(Sender: TObject);
  var n,s: integer;
begin
  Stop := False;
  button1.Hide;
  button3.hide;
  n := 2;
  listbox1.Items.Clear;
  repeat
    s := summeDerEchtenTeiler(n);
    if summeDerEchtenTeiler(s) = n then
      listbox1.Items.Add(IntToStr(n)+'   '+IntToStr(s));
    n := n + 1;
    if n mod 1000 = 0 then Begin
      application.ProcessMessages;
      if Stop then BEgin
        showmessage('Abbruch bei n='+IntToStr(n));
        button1.show;
        button3.Show;
        exit;
      ENd;
    End;
  until false;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Stop := True;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  close
end;

end.
